/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#include "StdAfx.h"
#include "parser.h"

#pragma warning(disable: 4244 4267)
//  BOOST
//http://www.boost.org
#define BOOST_REGEX_STATIC_LINK
#include <boost/regex.hpp>
#pragma warning(default: 4244 4267)

#include "Kernel.h"
extern struct PluginStartupInfo g_PluginInfo; 

namespace re	// 
{
//  
// LIST_COMMANDS   
//  RE_LIST_COMMANDS   
//  ,    
//      (     RE_PREFIX)
//        -  (   )
//     
	const int NUM_COMMANDS = 14;
	kr::tcommands_kinds LIST_COMMANDS[NUM_COMMANDS] = {
		kr::QK_OPEN_SHORTCUT		
		,kr::QK_INSERT_SHORTCUT_TEMPORARY_IMPLICIT	
		,kr::QK_INSERT_SHORTCUT_IMPLICIT	
		,kr::QK_DELETE_SHORTCUT_IMPLICIT	
		,kr::QK_INSERT_SHORTCUT
		,kr::QK_INSERT_SHORTCUT_TEMPORARY
		,kr::QK_INSERT_BOTH_TEMPORARY
		,kr::QK_INSERT_BOTH
		,kr::QK_DELETE_SHORTCUT
		,kr::QK_DELETE_CATALOG
		,kr::QK_OPEN_NETWORK
		,kr::QK_OPEN_PANEL
		,kr::QK_OPEN_BY_PATH
		,kr::QK_OPEN_ENVIRONMENT_VARIABLE

	};	//    RE_LIST_COMMANDS
	TCHAR const* LIST_RE[NUM_COMMANDS] = {
		_T("()([\\*\\?\\w\\d_].*)")
		,_T("(\\+)()$")
		,_T("(:)()$")
		,_T("(\\-)()$")
		,_T("(:)([^:\\+].*)")
		,_T("(\\+)([^:\\+].*)")
		,_T("(:\\+)(.*)")	//QK_INSERT_BOTH_TEMPORARY
		,_T("(::)(.*)")
		,_T("(\\-)(.*[^\\/]\\s*)")
		,_T("(\\-)(.*\\/\\s*)")
		,_T("(\\\\)(.*)")
		,_T("(\\s*)()$")
		,_T("(~)(.*)")
		,_T("(%)(.*)")
	};
// 
	TCHAR const * RE_PREFIX = _T("^(\\w+):");
// /\
	TCHAR const * RE_CSD = _T("([^\\\\]*\\/)?([^\\/\\\\]*)?(\\\\[^\\s]*)?(\\s+.+)?");
//		_T("([^\\\\]*\\/)?([^\\/\\\\]*)?(\\\\[^\\s]+)?(\\s+.+)?");

#ifndef UNICODE
	typedef boost::regex tregex;
	typedef boost::cmatch tcmatch;
#else
	typedef boost::wregex tregex;
	typedef boost::wcmatch tcmatch;
#endif
}


using namespace parser;
CParser::CParser(void)
{
}

CParser::~CParser(void)
{
}


bool CParser::ParseString(tstring const &source, 
						  kr::tparsed_command &t)
{
	tstring csdp;
	t.flags = 0;


	if (! get_command_kind(source, t.kind, t.prefix,  csdp)) return false;
	if (! t.prefix.empty()) t.flags = t.flags | kr::FGC_ENABLED_PREFIX;

	if (parse_csdp(csdp, t.catalog, t.shortcut, t.local_directory, t.param))
	{
		if (! t.catalog.empty()) t.flags = t.flags | kr::FGC_ENABLED_CATALOG;
		if (! t.shortcut.empty()) t.flags = t.flags | kr::FGC_ENABLED_SHORTCUT;
		if (! t.local_directory.empty()) t.flags = t.flags | kr::FGC_ENABLED_LOCAL_DIRECTORY;
		if (! t.param.empty()) t.flags = t.flags | kr::FGC_ENABLED_PARAM;
	};

	return true;
}

bool CParser::get_command_kind(tstring const& source, 
							   kr::tcommands_kinds &kind, 
							   tstring &prefix,
							   tstring &csdp)
{
	for (int i = 0; i < re::NUM_COMMANDS; ++i)
	{
		tstring rexp(re::RE_PREFIX);
		rexp += re::LIST_RE[i];	

		re::tregex expression(rexp.c_str());
		
		re::tcmatch what;
		if (boost::regex_match(source.c_str(), what, expression))
		{
			{SHOW_DEBUG_INFO(_T("regex_match"));}
			prefix = what[1];
			csdp = what[3];
			kind = re::LIST_COMMANDS[i];
			return true;
		}
	}

	return false;
}

bool CParser::parse_csdp(tstring const&csdp, tstring &c, tstring &s, tstring &d, tstring &p)
{	// /\  
	re::tregex expression(re::RE_CSD);
	re::tcmatch what;
	if (boost::regex_match(csdp.c_str(), what, expression))
	{
		c = what[1];
		s = what[2];
		d = what[3];
		if (d.size() == 1) d.clear(); //  ;   
		p = what[4];
		return true;
	}

	return false;
}


bool parser::token_is_matched_to_pattern(tstring const &stoken
										 , tstring const &spattern
										 , bool bAddTrailingAsterix)
{
//	       ?  * (    - )
//	"a*"  "abc"  "a",  "b?"  "ba"  "bc"
	tstring p = spattern;
	if (bAddTrailingAsterix) 
	{
		tstring p = spattern + tstring(_T("*"));
		return g_PluginInfo.CmpName(p.c_str(), stoken.c_str(), FALSE);
	} else {
		return g_PluginInfo.CmpName(spattern.c_str(), stoken.c_str(), FALSE);
	}
}
