/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#include "StdAfx.h"
#include "executor_confirmations.h"
#include "Kernel.h"
#include "executor_menus.h"
#include "lang.h"
#include "header.h"

//       
//   
UINT nf::confirm_implicit_insert(HANDLE hPlugin
								 , kr::tshortcut_info const&cmd
								 , tstring const& value)
{
	BOOL bIsImplicitConfirmationRequired = g_pK->m_S.GetValue(nf::ST_CONFIRM_IMPLICIT_CREATION);	
	if (! bIsImplicitConfirmationRequired) 
		return 1;	//  

	const char *Msg[4];
	Msg[0] = GetMsg(lg::MSG_INSERT_SHORTCUT);      
	Msg[1] = GetMsg(lg::CONFIRM_INSERT_SHORTCUT);   
	Msg[2] = cmd.shortcut.c_str();
	Msg[3] = value.c_str();

	if (g_PluginInfo.Message(g_PluginInfo.ModuleNumber
		, FMSG_MB_OKCANCEL
		, 0
		, Msg
		, sizeof(Msg)/sizeof(Msg[0])
		, 3) == 0) return 2;
	else return 0;
}

//      
UINT nf::confirm_override(HANDLE hPlugin
						, kr::tshortcut_info const&cmd
						, tstring const& value)
{
	BOOL bIsOverrideConfirmationRequired = g_pK->m_S.GetValue(nf::ST_CONFIRM_OVERRIDE);	
	
	if (! bIsOverrideConfirmationRequired)
		return 1;	//  

	const char *Msg[5];

	tstring s = GetMsg(lg::MSG_OVERRIDE_SHORTCUT);
	s += _T(": ");
	s += cmd.shortcut;
	Msg[0] = s.c_str();      
	Msg[1] = GetMsg(lg::CONFIRM_OVERRIDE_SHORTCUT);   
	Msg[2] = value.c_str();
	Msg[3] = GetMsg(lg::MSG_OVERRIDE);      
	Msg[4] = GetMsg(lg::MSG_CANCEL);


	if (g_PluginInfo.Message(g_PluginInfo.ModuleNumber
		, FMSG_WARNING 
		, 0
		, Msg
		, sizeof(Msg)/sizeof(Msg[0])
		, 2) == 0) return 2;
	else return 0;
}

UINT nf::confirm_go_to_nearest(HANDLE hPlugin
							   , TCHAR const* OriginalDirectory
							   , TCHAR const* NearestDirectory)
{
	BOOL bIsConfirmationRequired = g_pK->m_S.GetValue(nf::ST_CONFIRM_GO_TO_NEAREST);	
	if (! bIsConfirmationRequired) return 1;	//  

	const char *Msg[5];

	Msg[0] = GetMsg(lg::MSG_ERROR);   
	Msg[1] = GetMsg(lg::MSG_PATH_NOT_FOUND);
	Msg[2] = OriginalDirectory;
	Msg[3] = GetMsg(lg::MSG_JUMP_TO_THE_NEAREST_EXISTING_FOLDER);
	Msg[4] = NearestDirectory;

	if (g_PluginInfo.Message(g_PluginInfo.ModuleNumber
		, FMSG_WARNING | FMSG_MB_YESNO
		, 0
		, Msg
		, sizeof(Msg)/sizeof(Msg[0])
		, 2) == 0) return 2;
	else return 0;
}

UINT nf::confirm_delete(HANDLE hPlugin
						, kr::tshortcut_info const& sh
						, bool bImplicit)
{
	BOOL bIsConfirmationRequired = g_pK->m_S.GetValue(nf::ST_CONFIRM_DELETE);	
	BOOL bIsImplicitConfirmationRequired = g_pK->m_S.GetValue(nf::ST_CONFIRM_IMPLICIT_DELETION);	

	if ((! bIsConfirmationRequired) && (! bIsImplicitConfirmationRequired)) 
		return 1;

	const char *Msg[5];

	Msg[0] = GetMsg(lg::MSG_DELETE_SHORTCUT);       
	Msg[1] = GetMsg(lg::CONFIRM_DELETE_SHORTCUT);   
	Msg[2] = sh.shortcut.c_str();
	Msg[3] = GetMsg(lg::MSG_DELETE);      
	Msg[4] = GetMsg(lg::MSG_CANCEL);


	if (g_PluginInfo.Message(g_PluginInfo.ModuleNumber
		, FMSG_WARNING 
		, 0
		, Msg
		, sizeof(Msg)/sizeof(Msg[0])
		, 2) == 0) return 2;
	else return 0;
}

UINT nf::confirm_delete_catalog(HANDLE hPlugin
								, kr::tcatalog_info const& cat
								, bool bIsEmpty)
{
	BOOL bConfirmDelete = g_pK->m_S.GetValue(nf::ST_CONFIRM_DELETE_CATALOGS);
	BOOL bConfirmDeleteNotEmpty = bIsEmpty && g_pK->m_S.GetValue(nf::ST_CONFIRM_DELETE_NOT_EMPTY_CATALOGS);
	if (! (bConfirmDelete || bConfirmDeleteNotEmpty))
		return 1;

	const char *Msg[5];

	Msg[0] = GetMsg(bConfirmDeleteNotEmpty ? lg::MSG_DELETE_CATALOG : lg::MSG_DELETE_CATALOG_NOT_EMPTY);       
	Msg[1] = GetMsg(lg::CONFIRM_DELETE_CATALOG);   
	Msg[2] = cat.c_str();
	Msg[3] = GetMsg(lg::MSG_DELETE);      
	Msg[4] = GetMsg(lg::MSG_CANCEL);


	if (g_PluginInfo.Message(g_PluginInfo.ModuleNumber
		, FMSG_WARNING 
		, 0
		, Msg
		, sizeof(Msg)/sizeof(Msg[0])
		, 2) == 0) return 2;
	else return 0;
}
