/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#pragma once

#include <vector>
#include "plugin.hpp"

//   
namespace nf
{
	typedef enum tsetting_strings
	{
		STS_PREFIXES

		, NUMBER_STRING_SETTINGS 
	} _tsetting_strings;

	typedef enum tsetting_flags 
	{	// 
		ST_SHOW_ERRORS					// 
		, ST_SHOW_IN_PLUGINS_MENU		//     
		, ST_SHOW_IN_DISK_MENU			//     
		, ST_SHOW_TEMPORARY_AS_HIDDEN	//     
		, ST_CONFIRM_DELETE				//   
		, ST_CONFIRM_DELETE_CATALOGS	//  
		, ST_CONFIRM_DELETE_NOT_EMPTY_CATALOGS //   
		, ST_CONFIRM_OVERRIDE			//   
		, ST_CONFIRM_IMPLICIT_CREATION	//     cd::, cd:+
		, ST_CONFIRM_IMPLICIT_DELETION	//     cd:-
		, ST_CONFIRM_GO_TO_NEAREST		//    
		, ST_SHOW_KEYS_IN_MENU		//    
		, ST_SELECT_SH_MENU_MODE	//      
		, ST_PANEL_MODE				//  
		, ST_SELECT_CATS_MENU_MODE	//      
		, ST_ALWAYS_EXPAND_SHORTCUTS	//   
		, ST_HISTORY_IN_DIALOG_APPLY_COMMAND	//     
		//   -      default_flags_values

		, NUMBER_FLAG_SETTINGS 
	} _tflag;

	class CSettings
	{
		std::vector<DWORD> m_FV;	//flag values
		std::vector<tstring> m_SV;	//string values
		tstring m_nf_reg_key;		//     NF
		tstring m_plugin_prefixes;	// 
	public:
		CSettings(void);
		~CSettings(void);

		void reload();
		void save();

//    
		DWORD GetValue(tsetting_flags fg) const;	
		tstring const& GetValue(tsetting_strings fg) const;
//     (  )
		void SetValue(tsetting_flags fg, DWORD Value);	
		void SetValue(tsetting_strings fg, tstring Value);

		tstring const& get_NamedFolders_reg_key() const { return m_nf_reg_key;}
	};

	inline const char *GetMsg(int MsgId) {return g_PluginInfo.GetMsg(g_PluginInfo.ModuleNumber, MsgId);}
};
